package ru.amse.javadependencies.zhukova.data.dependencies.impl;

import ru.amse.javadependencies.zhukova.data.IClass;
import ru.amse.javadependencies.zhukova.data.dependencies.IFeatureDependency;
import ru.amse.javadependencies.zhukova.data.dependencies.IClassDependency;

import java.util.Set;
import java.util.List;
import java.util.ArrayList;

/**
 * @author Anna R. Zhukova
 */
public class ClassDependency extends NotLeafDependency<IClass, IFeatureDependency> implements IClassDependency {

    public ClassDependency(IClass server, Set<IFeatureDependency> featureDependencies) {
        super(server, featureDependencies);
    }

    public ClassDependency(IClass server) {
        super(server);
    }

    public String toString() {
        return toString("  Feature_Dependencies:\n", 7);
    }

    /*public boolean equals(Object obj) {
	    if (this == obj) {
            return true;
        }
        if (!(obj instanceof ClassDependency)) {
            return false;
        }
        ClassDependency cd = (ClassDependency) obj;
        return this.getServer().getName().equals(cd.getServer().getName()) && this.getServer().getPackage().getName().equals(cd.getServer().getPackage().getName());
    }*/
    public List<String> subdependenciesToStringList() {
        List<String> result = new ArrayList<String>();
        Set<IFeatureDependency> subdependencies = getSubdependencies();
        for (IFeatureDependency dependency : subdependencies) {
            result.add(dependency.toString());
        }
        return result;
    }
}
