package ru.amse.javadependencies.zhukova.data.dependencies.impl;

import ru.amse.javadependencies.zhukova.data.IClass;
import ru.amse.javadependencies.zhukova.data.dependencies.IFeatureDependency;

/**
 * @author Anna R. Zhukova
 */
public abstract class FeatureDependency extends Dependency<IClass> implements IFeatureDependency {
    private String myClientFeatureName;
    private String myServerFeatureName;

    public FeatureDependency(IClass server, String clientFeatureName, String serverFeatureName) {
        super(server);
        myClientFeatureName = clientFeatureName;
        myServerFeatureName = serverFeatureName;
    }

    public FeatureDependency(IClass server) {
        super(server);
    }

    public String getServerFeatureName() {
        return myServerFeatureName;
    }

    public String getClientFeatureName() {
        return myClientFeatureName;
    }

    public void setServerFeatureName(String serverFeatureName) {
        myServerFeatureName = serverFeatureName;
    }

    public void setClientFeatureName(String clientFeatureName) {
        myClientFeatureName = clientFeatureName;
    }

    public String toString() {
        StringBuilder result = new StringBuilder(" clientFeature: ");
        result.append(myClientFeatureName);
        result.append("; serverFeature: ");
        result.append(myServerFeatureName);
        return result.toString();
    }
}
