package ru.amse.javadependencies.zhukova.data.impl;

import ru.amse.javadependencies.zhukova.data.IClass;
import ru.amse.javadependencies.zhukova.data.IPackage;

/**
 * @author Anna R. Zhukova
 */
public class Class extends JavaElement implements IClass {
    private IPackage myPackage;

    public Class() {
        super();
    }

    public Class(String name, IPackage _package) {
        super(name);
        myPackage = _package;
    }

    public Class(String name) {
        this(name, null);
    }

    public IPackage getPackage() {
        return myPackage;
    }

    public String toString() {
        if (myPackage == null) {
            return "package: " + "\n" + super.toString();
        }
        return "package: " + myPackage.getName() + "\n" + super.toString();
    }

    public String getFullName() {
        return ((myPackage != null) ? myPackage.getName() : "") + "." + getName();
    }
}
