package ru.amse.javadependencies.zhukova.ui.commands;

import java.util.LinkedList;
import java.util.Iterator;

public class Composite implements ICommand {
    private final LinkedList<ICommand> myCommands;

    public Composite(){
        myCommands = new LinkedList<ICommand>();
    }

    public void addCommand(ICommand c){
        myCommands.add(c);
    }

    public void doIt() {
        for (ICommand cmd : myCommands) {
            cmd.doIt();
        }
    }

    public void undo() {
        for (Iterator<ICommand> it = myCommands.descendingIterator(); it.hasNext(); ) {
            ICommand cmd = it.next();
            cmd.undo();
        }
    }
}
