package ru.amse.javadependencies.zhukova.ui.graphpane.tools;

import ru.amse.javadependencies.zhukova.model.*;
import ru.amse.javadependencies.zhukova.model.impl.SuperVertex;
import ru.amse.javadependencies.zhukova.model.impl.SimpleVertex;
import ru.amse.javadependencies.zhukova.ui.graphpane.GraphPane;

import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.awt.*;
import java.util.*;

/**
 * @author Anna R. Zhukova
 */
public class ToolTipMouseMotionListener extends MouseAdapter {
    private final GraphPane ourGraphPane;

    public ToolTipMouseMotionListener(GraphPane gp) {
        ourGraphPane = gp;
    }
    
    public void mouseMoved(MouseEvent e) {
        IGraphModel gm = ourGraphPane.getGraphModel();
        if (gm != null) {
            Point mouseLocation = e.getPoint();
            Collection<SimpleVertex> simpleVertices = gm.getNameToSimpleVertexMap().values();
            for (IVertex vertex : simpleVertices) {
                if (vertex.hitTest(mouseLocation) && !vertex.isHidden()) {
                    ourGraphPane.setToolTipText(vertex.getToolTipText());
                    return;
                }
            }
            Set<IArc> arcs = gm.getArcs();
            for (IArc arc : arcs) {
                if (arc.hitTest(mouseLocation)) {
                    ourGraphPane.setToolTipText(arc.getToolTipHTML());
                    return;
                }
            }
            Collection<SuperVertex> superVertices = gm.getNameToSuperVertexMap().values();
            for (IVertex vertex : superVertices) {
                if (vertex.hitTest(mouseLocation) && !vertex.isHidden()) {
                    ourGraphPane.setToolTipText(vertex.getToolTipText());
                    return;
                }
            }
            ourGraphPane.setToolTipText(null);
        }
    }
}
